c     Kernel function for default format
      real*8 function Kernel(M,x,y)
      use kernel_params
      implicit real*8(a-h,o-z)

      integer M,L
      real*8  x(M),y(M),d

#ifdef Linear
      Kernel=ddot(M,x,1,y,1)
#else
      L=mod(M,8)
      d=0.d0
      do i=1,L
        d=d+(x(i)-y(i))*(x(i)-y(i))
      end do
      do i=L+1,M,8
        d=d+(x(i)-y(i))*(x(i)-y(i))
        d=d+(x(i+1)-y(i+1))*(x(i+1)-y(i+1))
        d=d+(x(i+2)-y(i+2))*(x(i+2)-y(i+2))
        d=d+(x(i+3)-y(i+3))*(x(i+3)-y(i+3))
        d=d+(x(i+4)-y(i+4))*(x(i+4)-y(i+4))
        d=d+(x(i+5)-y(i+5))*(x(i+5)-y(i+5))
        d=d+(x(i+6)-y(i+6))*(x(i+6)-y(i+6))
        d=d+(x(i+7)-y(i+7))*(x(i+7)-y(i+7))
      end do
      Kernel=exp(-gamma*d)
#endif
      
      return
      end

c     Kernel function for sparse format
      real*8 function Kernel_s(nx,x,px,mx,ny,y,py,my,imax)
      use kernel_params
      implicit real*8(a-h,o-z)

      integer M,mx,my,imax,lx,ly
      integer px(nx),py(ny)
      real*8  x(nx),y(ny),d

#ifdef Linear
      d=0.d0
      lx=1
      ly=1
      do while (px(lx) .ne. -1 .and. py(ly) .ne. -1)
        if (px(lx) .eq. py(ly)) then
          d=d+x(lx)*y(ly)
          lx=lx+1
          ly=ly+1
        else
          if (px(lx) .gt. py(ly)) then
            ly=ly+1
          else
            lx=lx+1
          end if
        end if
      end do
      Kernel_s=d
#else
      d=0.d0
      lx=1
      ly=1
      do while (px(lx) .ne. -1 .and. py(ly) .ne. -1)
        if (px(lx) .eq. py(ly)) then
          d=d+x(lx)*y(ly)
          lx=lx+1
          ly=ly+1
        else
          if (px(lx) .gt. py(ly)) then
            ly=ly+1
          else
            lx=lx+1
          end if
        end if
      end do

      x2=0.d0
      do i=1,mx
        x2=x2+x(i)*x(i)
      end do

      y2=0.d0
      do i=1,my
        y2=y2+y(i)*y(i)
      end do

      d=x2+y2-2.d0*d
      Kernel_s=exp(-gamma*d)
#endif

      return
      end
      
